// Copyright (C) 2006 Pushok Software http://www.pushok.com/soft_svncom.php
//
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//
// Subversion is Copyrght of(c) 2000-2004 CollabNet.  All rights reserved.
// Full license available here http://subversion.tigris.org/license-1.html.

#pragma once
#include "resource.h"       // main symbols

#include "pcom.h"


// CSVNWcNotify

class ATL_NO_VTABLE CSVNWcNotify : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CSVNWcNotify, &CLSID_SVNWcNotify>,
	public ISupportErrorInfo,
	public IDispatchImpl<ISVNWcNotify, &IID_ISVNWcNotify, &LIBID_PushOkSvn, /*wMajor =*/ 1, /*wMinor =*/ 0>
{
public:
	CSVNWcNotify()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_SVNWCNOTIFY)

BEGIN_COM_MAP(CSVNWcNotify)
	COM_INTERFACE_ENTRY(ISVNWcNotify)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

	DECLARE_PROTECT_FINAL_CONSTRUCT()
	DECLARE_GET_CONTROLLING_UNKNOWN()

	HRESULT FinalConstruct()
	{
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}
	
	void FinalRelease() 
	{
		m_pUnkMarshaler.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;

public:
	STDMETHOD(put_Path)(BSTR sVal) {
		LOCK_THIS_OBJ
		path = sVal;
		return S_OK;
	}
	STDMETHOD(get_Path)(BSTR* psVal) {
		LOCK_THIS_OBJ
		return path.CopyTo(psVal);
	}
	STDMETHOD(put_Action)(SvnWcNotifyAction Val) {
		LOCK_THIS_OBJ
		action = Val;
		return S_OK;
	}
	STDMETHOD(get_Action)(SvnWcNotifyAction* pVal) {
		if (!pVal)
			return E_INVALIDARG;
		LOCK_THIS_OBJ
		*pVal = action;
		return S_OK;
	}
	STDMETHOD(put_Kind)(SvnNodeKind Val) {
		LOCK_THIS_OBJ
		kind = Val;
		return S_OK;
	}
	STDMETHOD(get_Kind)(SvnNodeKind* pVal) {
		if (!pVal)
			return E_INVALIDARG;
		LOCK_THIS_OBJ
		*pVal = kind;
		return S_OK;
	}
	STDMETHOD (put_Lock)(ISVNLock* pVal) {
		LOCK_THIS_OBJ
		lock = pVal;
		return S_OK;
	}
	STDMETHOD (get_Lock)(ISVNLock** ppVal) {
		LOCK_THIS_OBJ
		return lock.CopyTo(ppVal);
	}
	STDMETHOD(put_CodeError)(LONG lVal) {
		LOCK_THIS_OBJ
		lerr = lVal;
		return S_OK;
	}
	STDMETHOD(get_CodeError)(LONG* plVal) {
		if (!plVal)
			return E_INVALIDARG;
		LOCK_THIS_OBJ
		*plVal = lerr;
		return S_OK;
	}
	STDMETHOD(put_StrError)(BSTR sVal) {
		LOCK_THIS_OBJ
		serr = sVal;
		return S_OK;
	}
	STDMETHOD(get_StrError)(BSTR* psVal) {
		LOCK_THIS_OBJ
		return serr.CopyTo(psVal);
	}
	STDMETHOD(put_ContState)(SvnWcNotifyState Val) {
		LOCK_THIS_OBJ
		content_state = Val;
		return S_OK;
	}
	STDMETHOD(get_ContState)(SvnWcNotifyState* pVal) {
		if (!pVal)
			return E_INVALIDARG;
		LOCK_THIS_OBJ
		*pVal = content_state;
		return S_OK;
	}
	STDMETHOD(put_PropState)(SvnWcNotifyState Val) {
		LOCK_THIS_OBJ
		prop_state = Val;
		return S_OK;
	}
	STDMETHOD(get_PropState)(SvnWcNotifyState* pVal) {
		if (!pVal)
			return E_INVALIDARG;
		LOCK_THIS_OBJ
		*pVal = prop_state;
		return S_OK;
	}
	STDMETHOD(put_LockState)(SvnWcNotifyLockState Val) {
		LOCK_THIS_OBJ
		lock_state = Val;
		return S_OK;
	}
	STDMETHOD(get_LockState)(SvnWcNotifyLockState* pVal) {
		if (!pVal)
			return E_INVALIDARG;
		LOCK_THIS_OBJ
		*pVal = lock_state;
		return S_OK;
	}
	STDMETHOD(put_Revision)(LONG lVal) {
		LOCK_THIS_OBJ
		revision = lVal;
		return S_OK;
	}
	STDMETHOD(get_Revision)(LONG* plVal) {
		if (!plVal)
			return E_INVALIDARG;
		LOCK_THIS_OBJ
		*plVal = revision;
		return S_OK;
	}
private:
	CComBSTR path;
	SvnWcNotifyAction action;
	SvnNodeKind kind;
	CComPtr<ISVNLock> lock;
	LONG lerr;
	CComBSTR serr;
	SvnWcNotifyState content_state;
	SvnWcNotifyState prop_state;
	SvnWcNotifyLockState lock_state;
	LONG revision;
};

OBJECT_ENTRY_AUTO(__uuidof(SVNWcNotify), CSVNWcNotify)

namespace PushokAtlEx
{
	template <>
	class GenericCopy< VARIANT, ISVNWcNotify* >
	{
	public :
		static void init(VARIANT* p)
		{
			GenericCopy<VARIANT>::init(p);
		}
		static void destroy(VARIANT* p)
		{
			GenericCopy<VARIANT>::destroy(p);
		}
		static HRESULT copy( VARIANT *pTo, ISVNWcNotify* *pFrom)
		{
			CComVariant vt((IDispatch *)*pFrom);
			return vt.Detach(pTo);
			return S_OK;
		}
	}; // class GenericCopy<VARIANT, ISVNWcNotify* pVal>
}

namespace SVNWcNotifyVector_
{
	// Store our data in a vector of std::strings
	typedef PushokAtlEx::CComPtrAdapt<ISVNWcNotify> ItemType;
	typedef std::vector<ItemType> ContainerType;

	// Now we have all the information we need to fill in the template arguments on the implementation classes
	typedef CComEnumOnSTL< IEnumVARIANT, &__uuidof(IEnumVARIANT), VARIANT,
							PushokAtlEx::GenericCopy< VARIANT, ItemType >, ContainerType > EnumeratorType;

	typedef ICollectionOnSTLImpl< ISVNWcNotifyVector, ContainerType, ISVNWcNotify*,
							PushokAtlEx::GenericCopy<ISVNWcNotify*, ItemType>, EnumeratorType > CollectionType;
};

class ATL_NO_VTABLE CSVNWcNotifyVector : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CSVNWcNotifyVector, &CLSID_SVNWcNotifyVector>,
	public IDispatchImpl<SVNWcNotifyVector_::CollectionType,&__uuidof(ISVNWcNotifyVector)>
{
public:
	CSVNWcNotifyVector()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_SVNWCNOTIFYVECTOR)

BEGIN_COM_MAP(CSVNWcNotifyVector)
	COM_INTERFACE_ENTRY(ISVNWcNotifyVector)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
END_COM_MAP()


	DECLARE_PROTECT_FINAL_CONSTRUCT()
	DECLARE_GET_CONTROLLING_UNKNOWN()

	HRESULT FinalConstruct()
	{
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}
	
	void FinalRelease() 
	{
		m_pUnkMarshaler.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;

public:
	STDMETHOD(Add)(ISVNWcNotify* pVal) {
		LOCK_THIS_OBJ
		m_coll.push_back(pVal);
		return S_OK;
	}
	STDMETHOD(Remove) (long Index) {
		LOCK_THIS_OBJ
		try {
			m_coll.erase(m_coll.begin() + Index);
		} catch(...) {
			return E_FAIL;
		}
		return S_OK;
	}
	STDMETHOD(Clear) (void) {
		LOCK_THIS_OBJ
		m_coll.clear();
		return S_OK;
	}
};

OBJECT_ENTRY_AUTO(__uuidof(SVNWcNotifyVector), CSVNWcNotifyVector)