// Copyright (C) 2006 Pushok Software http://www.pushok.com/soft_svncom.php
//
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//
// Subversion is Copyrght of(c) 2000-2004 CollabNet.  All rights reserved.
// Full license available here http://subversion.tigris.org/license-1.html.

#pragma once
#include "resource.h"       // main symbols

#include "pcom.h"

// CSVNWcStatusInfo

class ATL_NO_VTABLE CSVNWcStatusInfo : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CSVNWcStatusInfo, &CLSID_SVNWcStatusInfo>,
	public ISupportErrorInfo,
	public IDispatchImpl<ISVNWcStatusInfo, &IID_ISVNWcStatusInfo, &LIBID_PushOkSvn, /*wMajor =*/ 1, /*wMinor =*/ 0>
{
public:
	CSVNWcStatusInfo()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_SVNWCSTATUSINFO)

BEGIN_COM_MAP(CSVNWcStatusInfo)
	COM_INTERFACE_ENTRY(ISVNWcStatusInfo)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

	DECLARE_PROTECT_FINAL_CONSTRUCT()
	DECLARE_GET_CONTROLLING_UNKNOWN()

	HRESULT FinalConstruct()
	{
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}
	
	void FinalRelease() 
	{
		m_pUnkMarshaler.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;

public:
	STDMETHOD(get_Files)(IStringVector ** pVal) {
		LOCK_THIS_OBJ
		return m_oFiles.CopyTo(pVal);
	}
	STDMETHOD(put_Files)(IStringVector * pVal) {
		LOCK_THIS_OBJ
		m_oFiles=pVal;
		return S_OK;
	}
	STDMETHOD(get_Textual)(IStringMap** pVal) {
		LOCK_THIS_OBJ
		return m_oTextual.CopyTo(pVal);
	}
	STDMETHOD(put_Textual)(IStringMap* pVal) {
		LOCK_THIS_OBJ
		m_oTextual=pVal;
		return S_OK;
	}
	STDMETHOD(get_Binary)(ISVNWcStatusCollection** pVal) {
		LOCK_THIS_OBJ
		return m_oBinary.CopyTo(pVal);
	}
	STDMETHOD(put_Binary)(ISVNWcStatusCollection* pVal) {
		LOCK_THIS_OBJ
		m_oBinary = pVal;
		return S_OK;
	}

private:
	CComPtr<IStringVector>			m_oFiles;
	CComPtr<IStringMap>				m_oTextual;
	CComPtr<ISVNWcStatusCollection> m_oBinary;
};

OBJECT_ENTRY_AUTO(__uuidof(SVNWcStatusInfo), CSVNWcStatusInfo)
